'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ticToc = require('tic-toc');

var _spinner = require('./spinner');

var _spinner2 = _interopRequireDefault(_spinner);

var _service = require('./service');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (options) {
  (0, _ticToc.tic)();
  _winston2.default.debug('Starting download with options: ' + JSON.stringify(options, null, 4));
  if (options.verbose && !options.debug) {
    _spinner2.default.start();
  }
  if (options.verbose && !options.debug) {
    _spinner2.default.text('Fetching iTunes data...');
  }
  _winston2.default.debug('Fetching iTunes data...');
  (0, _service.fetchFromiTunes)(options).then(function (track) {
    return (0, _service.fetchFromYoutube)(_extends({}, options, track));
  }).then(function (track) {
    return (0, _service.download)(track);
  }).then(function () {
    if (options.verbose && !options.debug) {
      _spinner2.default.succeed('Download complete in ' + _chalk2.default.bold(Math.round((0, _ticToc.toc)() * 100) / 100 + 's') + '!');
    } else if (options.debug) {
      _winston2.default.debug('Completed in ' + Math.round((0, _ticToc.toc)() * 100) / 100 + 's');
    }
  }).catch(function (error) {
    if (options.verbose && !options.debug) {
      _spinner2.default.fail(error.message);
    } else if (options.debug) {
      _winston2.default.error('Failed with error: ' + error.message);
    }
  });
};