'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var spinner = (0, _ora2.default)({ text: 'Starting download...' });

exports.default = {
  start: function start() {
    return spinner.start();
  },
  text: function text(_text) {
    spinner.text = _text;
  },
  warn: function warn(text) {
    var proceed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

    var newSpinner = spinner.warn(text);
    spinner = newSpinner;
    if (proceed) {
      spinner.text = 'Proceeding...';
      spinner.start();
    }
  },
  succeed: function succeed(text) {
    var newSpinner = spinner.succeed(text);
    spinner = newSpinner;
  },
  fail: function fail(text) {
    var newSpinner = spinner.fail(text);
    spinner = newSpinner;
  }
};